#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <wiringPiSPI.h>
#include <unistd.h>
#include <sys/time.h>
#include <stdint.h>

/*
struct kedrigernMouth * kedrigern_allocMouth(void);
void kedrigern_AddParam(struct kedrigernMouth *mouth, const char *name, const char *value);
void kedrigern_InitMouth(struct kedrigernMouth *mouth);
void kedrigern_StartMouth(struct kedrigernMouth *mouth, char *phonemes, double factor);
void kedrigern_SetParam(struct kedrigernMouth *mouth, const char *param, const char *value);
void kedrigern_Free(struct kedrigernMouth *mouth);
void kedrigern_ShowMouth(struct kedrigernMouth *mouth, int millis);
void kedrigern_ShowPhoneme(struct kedrigernMouth *mouth, int phoneme);
void kedrigern_EndSpeaking(struct kedrigernMouth *mouth);
void kedrigern_AutoHide(struct kedrigernMouth *mouth);
*/

#define BANK_COUNT 2
#define constrain(a, b, c) ((a < (b)) ? (b): (a > (c)) ? (c) : a)

char *pna[]={"0","A","E","I","O","U","Y","P","M","F","W","X","etc","-",":)",""};
enum {
    PHONE_BLANK = 0,
    PHONE_A,
    PHONE_E,
    PHONE_I,
    PHONE_O,
    PHONE_U,
    PHONE_Y,
    PHONE_P,
    PHONE_M,
    PHONE_F,
    PHONE_W,
    PHONE_X,
    PHONE_ETC,
    PHONE_SIL,
    PHONE_REST,
    PHONE_COUNT};

/* max7219 */
static void matrix_Write(int matrix, uint8_t adr, uint8_t data)
{
    uint8_t buf[2];
    buf[0] = adr;
    buf[1] = data;
    write(matrix, buf, 2);
}

static void matrix_Brightness(int matrix, int brightness)
{
    matrix_Write(matrix, 0x0a, brightness);
}

static void matrix_Mode(int matrix, int mode)
{
    matrix_Write(matrix, 0x09, mode);
}

static void matrix_Scanlimit(int matrix, int limit)
{
    matrix_Write(matrix, 0x0b, limit);
}

static void matrix_PowerUp(int matrix, int mode)
{
    matrix_Write(matrix, 0x0c, mode);
}

static void matrix_Shape(int matrix, uint8_t *shape)
{
    int i;
    for (i=0; i<8; i++) matrix_Write(matrix, i+1,shape[i]);
}

static void matrix_TestMode(int matrix, int mode)
{
    matrix_Write(matrix, 0x0f, mode);
}
/* end 7219 */

static uint8_t paszcza_in[BANK_COUNT * PHONE_COUNT][8]={

// bank 0
    {0,0,0,0,0,0,0},  // BLANK
    {0xc3,0,0,0x3c,0x42,0x81,0x42,0x2c},  // A
    {0xc3,0,0,0x7e,0x81,0x81,0x81,0x7e},  // E
    {0xc3,0,0,0x7e,0x81,0x81,0x7e,0},  // I
    {0xc3,0,0,0x3c,0x42,0x42,0x42,0x3c},  // O
    //{0xc3,0,0x18,0x24,0x24,0x18,0},  // U
    {0xc3,0,0,0x18,0x24,0x18,0},  // U
    {0xc3,0,0,0x7e,0x81,0x42,0x3c,0},  // Y
    {0xc3,0,0,0,0xff,0x7e,0,0},  // P
    {0xc3,0,0,0,0xff,0x7e,0,0},  // M
    {0xc3,0,0,0x7e,0x81,0x7e,0},  // F
    {0xc3,0,0,0x3c,0x42,0x24,0x18,0},  // W
    {0xc3,0,0,0x3c,0x42,0x3c,0},  // X
    {0xc3,0,0,0x3c,0x42,0x3c,0},  // ETC
    {0xc3,0,0,0,0x3c,0,0,0},  // SIL
    {0xc3,0,0,0,0x66,0x3c,0,0},  // REST
// bank 1 (bez oczek)
    {0,0,0,0,0,0,0},  // BLANK
    {0,0,0x3c,0x42,0x81,0x42,0x2c},  // A
    {0,0,0x7e,0x81,0x81,0x81,0x7e},  // E
    {0,0,0x7e,0x81,0x81,0x7e,0},  // I
    {0,0,0x3c,0x42,0x42,0x42,0x3c},  // O
    {0,0,0x18,0x24,0x18,0},  // U
    {0,0,0x7e,0x81,0x42,0x3c,0},  // Y
    {0,0,0,0xff,0x7e,0,0},  // P
    {0,0,0,0xff,0x7e,0,0},  // M
    {0,0,0x7e,0x81,0x7e,0},  // F
    {0,0,0x3c,0x42,0x24,0x18,0},  // W
    {0,0,0x3c,0x42,0x3c,0},  // X
    {0,0,0x3c,0x42,0x3c,0},  // ETC
    {0,0,0,0x7e,0,0,0},  // SIL
    {0,0,0x66,0x3c,0,0}  // REST



    };

struct mouthem {
    unsigned int shape:5;
    unsigned int stress:3;
    int time:24;
};

struct kedrigernMouth {
    int spi_device;
    int brightness;
    int autoblank;
    int bank;
    int rotation;
    char *shape;
    // tyle parametrów
    uint8_t paszcza[PHONE_COUNT][8];
    int matrix;
    struct mouthem *mouthem;
    int mouthem_len, mouthem_size, mouthem_pos;
    int shine;
    struct timeval last_final;
};



struct kedrigernMouth * kedrigern_allocMouth(void)
{
    struct kedrigernMouth *mouth = malloc(sizeof(*mouth));
    memset(mouth, 0, sizeof(*mouth));
    return mouth;
}

void kedrigern_InitMouth(struct kedrigernMouth *mouth)
{
    uint8_t shapaszcza[PHONE_COUNT][8];

    void rotate(uint8_t *in, uint8_t *out, int mode)
    {
        int x, y;
        int get_point(int x, int y)
        {
            return (in[x] & (1<<y)) ? 1 : 0;
        }
        void set_point(int x,int y) {
            out[x] |= 1<<y;
        }
        
        switch(mode) {
            case 1:
            for (x=0; x< 8; x++) for (y=0; y < 8; y++) {
                if (get_point(y,7-x)) set_point(x,y);
            }
            break;
            
            case 2:
            for (x=0; x< 8; x++) for (y=0; y < 8; y++) {
                if (get_point(7-x,7-y)) set_point(x,y);
            }
            break;
            
            case 3:
            for (x=0; x< 8; x++) for (y=0; y < 8; y++) {
                if (get_point(7-y,x)) set_point(x,y);
            }
            break;
            
            default:
            memcpy(out, in, 8);
        }
    }

    
    void readShape(void)
    {
        FILE *f=fopen(mouth->shape,"r");
        char *s, *s1, buf[256];
        char *ts[]={"ETC", "SIL","REST","A","E","I","O","U","Y","P","F","W",NULL};
        int i, nshape, j;
        uint8_t cs[]={PHONE_ETC, PHONE_SIL, PHONE_REST,
            PHONE_A, PHONE_E, PHONE_I, PHONE_O, PHONE_U, PHONE_Y,
            PHONE_P, PHONE_F, PHONE_W, 0};
        
        uint8_t decodeShapeLine(char *c)
        {
            int i;
            uint8_t rc=0;
            for (i=0;i<8;i++) {
                if (!c[i]) break;
                if (!isspace(c[i]) && c[i] !='.') rc |= 128 >> i;
            }
            return rc;
        }
    
        char *despace(char *c)
        {
            while (*c && isspace(*c)) c++;
            return c;
        }
        if (!f) {
            perror(mouth -> shape);
            return;
        }
        while (fgets(buf,256,f)) {
            s=despace(buf);
            if (!*buf == '#') continue;
            if (strncasecmp(s,"shape",5) || !isspace(s[5])) continue;
            s=despace(s+5);
            for (i=0;ts[i];i++) {
                if (!strncasecmp(s,ts[i],strlen(ts[i]))) {
                    s=despace(s+strlen(ts[i]));
                    if (!*s || *s == '#') break;
                }
            }
            if (!ts[i]) continue;
            nshape = cs[i];
            for (j=0;j<8;j++) {
                if (!fgets(buf,256,f)) break;
                shapaszcza[nshape][j] = decodeShapeLine(buf);
            }
            if (nshape == PHONE_P) memcpy(shapaszcza[PHONE_M],shapaszcza[PHONE_P],8);
            if (nshape == PHONE_ETC) memcpy(shapaszcza[PHONE_X],shapaszcza[PHONE_ETC],8);
        }
        fclose(f);
    }
    
    mouth->matrix = wiringPiSPISetup(mouth->spi_device,500000);
    if (mouth->matrix < 0) {
        perror("Bład inicjalizacji SPI");
        exit(1);
    }
    matrix_Brightness(mouth->matrix, mouth->brightness);
    matrix_Mode(mouth->matrix, 0);
    matrix_Scanlimit(mouth->matrix,7);
    matrix_PowerUp(mouth->matrix, mouth->autoblank ? 0 :1);
    matrix_TestMode(mouth->matrix, 0);
    mouth->bank = constrain(mouth->bank, 0, BANK_COUNT-1);
    memcpy(shapaszcza, paszcza_in[mouth->bank * PHONE_COUNT],8*PHONE_COUNT);
    if (mouth->shape) {
        readShape();
    }
    for (int i = 0; i < PHONE_COUNT; i++) {
        rotate(shapaszcza[i], mouth->paszcza[i], mouth->rotation);
    }
    matrix_Shape(mouth->matrix, mouth->paszcza[PHONE_REST]);
}



void kedrigern_AddParam(struct kedrigernMouth *mouth, const char *name, const char *value)
{
    if (strncasecmp(name, "matrix:", 7)) return;
    name += 7;
    char buf[strlen(name) + 1];
    if (!value) {
        strcpy(buf,name);
        name=buf;
        char *c = strchr(buf,'=');
        if (!c) return;
        char *d=c-1;
        *c++=0;
        while (*c && isspace(*c)) c++;
        value = c;
        while (d >= buf) {
            if (!isspace(*d)) {
                d[1]=0;
                break;
            }
        }
    }
    if (!strcasecmp(name,"spi_device")) mouth -> spi_device = atoi(value) & 1;
    else if (!strcmp(name,"brightness")) mouth -> brightness = constrain(atoi(value), 0, 15);
    else if (!strcasecmp(name,"autoblank")) mouth -> autoblank = constrain(atoi(value), 0, 1024);
    else if (!strcasecmp(name,"bank")) mouth -> bank = constrain(atoi(value), 0, BANK_COUNT-1);
    else if (!strcasecmp(name,"rotation")) mouth -> rotation = constrain(atoi(value), 0, 3);
    else if (!strcasecmp(name,"shape")) mouth -> shape = strdup(value);
}

void kedrigern_Free(struct kedrigernMouth *mouth)
{
    if (mouth->shape) free(mouth->shape);
    free(mouth);
}

void kedrigern_SetParam(struct kedrigernMouth *mouth, const char *param, const char *value)
{
    if (!strcasecmp(param,"matrix:brightness"))
        matrix_Brightness(mouth->matrix,  constrain(atoi(value), 0, 15));
    
}

static const char * milephon = "aVbeWpfiJmoYuOwvyEUIxx";
static const uint8_t phonon[] = {
    PHONE_A,PHONE_Y,PHONE_P,PHONE_E,0,PHONE_P,PHONE_F,PHONE_I,0,
    PHONE_M,PHONE_O,PHONE_E,PHONE_U,PHONE_O,PHONE_W,PHONE_F,
    PHONE_Y,PHONE_E,PHONE_U,PHONE_Y,PHONE_X,PHONE_X};

static struct mouthem *add_mouthem(struct kedrigernMouth *mouth,
                uint8_t shape, int time, int stress)
{
    if (!mouth->mouthem_size) {
        mouth ->mouthem = malloc(sizeof(struct mouthem) * (mouth -> mouthem_size = 1024));
        mouth -> mouthem_len=0;
    }
    else if (mouth -> mouthem_len >= mouth -> mouthem_size) {
        mouth -> mouthem_size *= 2;
        mouth -> mouthem = realloc(mouth -> mouthem,
            sizeof(struct mouthem) * (mouth -> mouthem_size = 1024));
    }
    mouth -> mouthem[mouth -> mouthem_len].shape = shape;
    mouth -> mouthem[mouth -> mouthem_len].time = time;
    mouth -> mouthem[mouth -> mouthem_len].stress = stress;
    
    return mouth ->mouthem + (mouth -> mouthem_len++);
}

static void add_line(struct kedrigernMouth *mouth, char *line)
{
    int ti, pho=0, stres=0;
    if (line[0] == ';' && line[1] == 'M') {
        line += 2;
        while (*line && isspace(*line)) line++;
        if (!*line) return;
        char *c=strchr(milephon,*line);
        if (!c) pho = PHONE_ETC;
        else pho = phonon[c-milephon];
        stres=strtol(line+1, NULL, 10)+1;
        ti=0;
        
    }
    else if (line[0]=='_') {
        ti=strtol(line+1, NULL, 10);
        pho = PHONE_SIL;
    }
    else {
        pho=0;
        while (*line && !isspace(*line)) line++;
        ti = strtol(line,NULL, 10);
    }
    if (!pho && !mouth->mouthem_len) {
        add_mouthem(mouth, PHONE_SIL,ti, 0);
        return;
    }
    if (!pho) {
        mouth->mouthem[mouth->mouthem_len -1].time += ti;
        return;
    }
    if (mouth->mouthem_len && 
            mouth->mouthem[mouth->mouthem_len -1].shape == PHONE_P &&
            (pho == PHONE_P || pho == PHONE_M)) {
        int t = mouth->mouthem[mouth->mouthem_len -1].time;
        mouth->mouthem[mouth->mouthem_len -1].time = (t * 2) / 3;
        add_mouthem(mouth, PHONE_ETC,
                t - mouth->mouthem[mouth->mouthem_len -1].time, 0);
    }
    else if (pho == PHONE_SIL &&
            mouth->mouthem_len &&
            mouth->mouthem[mouth->mouthem_len -1].shape == PHONE_SIL) {
        mouth->mouthem[mouth->mouthem_len -1].time += ti;
        return;
    }
    add_mouthem(mouth, pho, ti, stres);
}

static void correct_mouthems(struct kedrigernMouth *mouth)
{
    int dt = 0;
    int i;
    for (i=1;i<mouth->mouthem_len;i++) {
        mouth->mouthem[i].time -=  mouth->mouthem[i].time % 10;
        if (mouth->mouthem[i].shape == PHONE_X) {
            if (i < mouth->mouthem_len && mouth->mouthem[i+1].shape <= PHONE_Y) {
                mouth->mouthem[i].shape = mouth->mouthem[i+1].shape;
            }
            else if (mouth->mouthem[i-1].shape != PHONE_M &&
                mouth->mouthem[i-1].shape != PHONE_P &&
                mouth->mouthem[i-1].shape != PHONE_SIL) {
                    mouth->mouthem[i].shape =  mouth->mouthem[i-1].shape;
            }
        }
        if (mouth->mouthem[i-1].time > mouth->mouthem[i].time-10) {
            mouth->mouthem[i].time = mouth->mouthem[i-1].time+10;
        }
    }
}


void kedrigern_StartMouth(struct kedrigernMouth *mouth, char *phonemes, double factor)
{
    mouth->mouthem_len = 0;
    while (phonemes && *phonemes) {
        add_line(mouth, phonemes);
        phonemes = strchr(phonemes,'\n');
        if (!phonemes) break;
        while (*phonemes && isspace(*phonemes)) phonemes++;
    }
    int ti=0;
    for (int i=0; i<mouth -> mouthem_len; i++) {
        int t = mouth -> mouthem[i].time;
        mouth -> mouthem[i].time = ti * factor;
        ti += t;
    }
    correct_mouthems(mouth);
    matrix_PowerUp(mouth->matrix,1);
    mouth -> mouthem_pos = 0;
}

void kedrigern_ShowMouth(struct kedrigernMouth *mouth, int millis)
{
    int z = 0;
    if (millis < 0) {
        matrix_Shape(mouth->matrix, mouth->paszcza[PHONE_REST]);
        return;
    }
    for (;;) {
        if (mouth->mouthem_pos >= mouth->mouthem_len) break;
        if (mouth->mouthem[mouth->mouthem_pos].time >= millis+10) break;
        z = mouth->mouthem[mouth->mouthem_pos++].shape;
    }
    if (z) {
        matrix_Shape(mouth -> matrix, mouth->paszcza[z]);
    }
}

void kedrigern_ShowPhoneme(struct kedrigernMouth *mouth, int phoneme)
{
    matrix_Shape(mouth -> matrix, 
        mouth -> paszcza[constrain(phoneme, 0, PHONE_COUNT-1)]);
}

void kedrigern_EndSpeaking(struct kedrigernMouth *mouth)
{
    matrix_Shape(mouth->matrix, mouth->paszcza[PHONE_REST]);
    gettimeofday(&mouth -> last_final, NULL);
    mouth ->shine = 1;
}

void kedrigern_AutoHide(struct kedrigernMouth *mouth)
{
    struct timeval tv;
    if (!mouth->shine || !mouth->autoblank) return;
    gettimeofday(&tv, NULL);
    long delta = (tv.tv_sec - mouth->last_final.tv_sec);
    if (delta < 0 || delta > 2 * mouth -> autoblank) {
        matrix_PowerUp(mouth->matrix, 0);
        mouth -> shine = 0;
        return;
    }
    delta = 1000000 * delta + (tv.tv_usec - mouth->last_final.tv_usec);
    if (delta > mouth -> autoblank * 1000000) {
        matrix_PowerUp(mouth->matrix, 0);
        mouth -> shine = 0;
        return;
    }
}

const char *kedrigern_HelpModule(void)
{
    return "Parametry modułu:\n\
-m matrix:spi_device <device> - urządzenie SPI (0/1)\n\
-m matrix:autoblank <czas w sekundach> - automatyczne wygaszanie\n\
-m matrix:bank <numer banku> - numer banku kształtów(0..1)\n\
-m matrix:shape <plik> - nazwa pliku kształtów\n\
-m matrix:brightness <jasność> - jasność matrycy (0..15)\n\
-m matrix:rotation <obrót> - obrót matrycy (0..3)\n";
}



